﻿using System.Text;

using OpenPop.Mime.Decode;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 커스텀 폴백 디코더 처리하기 - CustomFallbackDecoder(characterSet)

        /// <summary>
        /// 커스텀 폴백 디코더 처리하기
        /// </summary>
        /// <param name="characterSet">문자 세트</param>
        /// <returns>인코딩</returns>
        private static Encoding CustomFallbackDecoder(string characterSet)
        {
            if(characterSet.StartsWith("foo"))
            {
                return Encoding.ASCII;
            }

            return Encoding.UTF8;
        }

        #endregion
        #region 커스텀 인코딩 추가하기 - AddCustomEncoding(customEncoding)

        /// <summary>
        /// 커스텀 인코딩 추가하기
        /// </summary>
        /// <param name="customEncoding">커스텀 인코딩</param>
        private static void AddCustomEncoding(Encoding customEncoding)
        {
            EncodingFinder.AddMapping("iso-9999-9"     , Encoding.UTF8 );
            EncodingFinder.AddMapping("specialEncoding", customEncoding);

            EncodingFinder.FallbackDecoder = CustomFallbackDecoder;
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            AddCustomEncoding(Encoding.Unicode);
        }

        #endregion
    }
}